<template>
    <div class="modal" v-show="show">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Редактирование пользователя</h5>
                    <button type="button" class="close" @click="$emit('close')">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form @submit.prevent="editEmployees">
                    <div class="modal-body">
                        <div class="mb-3">
                            <label for="image" class="form-label">Компания</label>
                            <input type="text" class="form-control" id="image" v-model="localUser.company.company">
                            <label for="name" class="form-label">Имя</label>
                            <input type="text" class="form-control" id="name" v-model="localUser.name">
                            <label for="position" class="form-label">Должность</label>
                            <input type="text" class="form-control" id="position" v-model="localUser.position">
                            <label for="date" class="form-label">Дата</label>
                            <input type="date" class="form-control" id="date" v-model="localUser.date">
                            <label for="phone" class="form-label">Телефон</label>
                            <input type="text" class="form-control" id="phone" v-model="localUser.phone">
                            <label for="email" class="form-label">Почта</label>
                            <input type="email" class="form-control" id="email" v-model="localUser.email">
                            <label for="salary" class="form-label">Зарплата</label>
                            <input type="text" class="form-control" id="salary" v-model="localUser.salary">
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" @click="$emit('close')">Закрыть</button>
                        <button type="submit" class="btn btn-primary">Сохранить изменения</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
import {mapActions} from "vuex";

export default {
    props: ['editableUser', 'show'],
    data() {
        return {
            localUser: this.createLocalUser(this.editableUser)
        };
    },
    watch: {
        // Отслеживаем изменения editableUser и обновляем localUser
        editableUser: {
            handler(newValue) {
                this.localUser = this.createLocalUser(newValue);
            },
            deep: true,
            immediate: true
        }
    },
    methods: {
        ...mapActions('employees', ['editUser']),
        createLocalUser(editableUser) {
            // Защита от null и undefined
            if (editableUser && editableUser.company) {
                return JSON.parse(JSON.stringify(editableUser));
            }

            return {
                company: { company: '' },
                name: '',
                position: '',
                date: '',
                phone: '',
                email: '',
                salary: ''
            };
        },
        async editEmployees() {
            await this.editUser(this.localUser);
            this.$emit('close');
        }
    },
};
</script>

<style scoped>
.modal {
    display: flex;
    align-items: center;
    justify-content: center;
}

.modal-dialog {
    margin: auto;
}
</style>
